//http://c5.hakker.com
//inspired from linsniff

#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <ioctls.h>
#include <net/if.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <linux/if_ether.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

int logudp=1,logicmp=1,logtcp=1,logabuse=1,promisc=1,log_all=1;
int resolv=0,log_intra=0,net_class=24,sock,log_out2intra=0;
char masq_ip[18],intranet[18],tcplogfile[256],udplogfile[256],device[6];
char icmplogfile[256],abuselogfile[256]; 
FILE *tcpfile,*udpfile,*icmpfile,*abusefile;

struct etherpacket{ 
 struct ethhdr eth;
 struct iphdr  ip;
 char buffert[2000];
} ep;

struct iphdr *ip;
struct tcphdr *tcp;
struct udphdr *udp;
struct icmphdr *icmp;

char *givetime(time_t *t){
 char *gtime;
 time(t);
 gtime=ctime(t);
 gtime[strlen(gtime)-6]=0;
 return gtime;
}

char *icmptype[]={
  "ECHOREPLY", "undef", "undef", "DEST_UNREACH", "SOURCE_QUENCH",
  "REDIRECT", "undef", "undef", "ECHO", "undef",
  "undef", "TIME_EXCEED", "PARAMETERPROB", "TIMESTAMP", "TIMESTAMPREPLY",
  "INFO_REQUEST", "INFO_REPLY", "ADDRESS", "ADDRESSREPLY"
};

char *icmpunreach[]={
"NET_UNREACH", "HOST_UNREACH", "PROT_UNREACH", "PORT_UNREACH", "FRAG_NEEDED",
  "SR_FAILED", "NET_UNKNOWN", "HOST_UNKNOWN", "HOST_ISOLATED", "NET_ANO",
"HOST_ANO", "NET_UNR_TOS", "HOST_UNR_TOS", "PKT_FILTERED", "PREC_VIOLATION",
  "PREC_CUTOFF"
};

char *icmpredirect[]={
  "REDIR_NET", "REDIR_HOST", "REDIR_NETTOS", "REDIR_HOSTTOS"
};

char *icmptime[]={
  "EXC_TTL", "EXC_FRAGTIME"
};


char *hostlookup(unsigned long int in,int fres){
 static char focus[1024];
 struct in_addr i;
 struct hostent *he;

 i.s_addr=in;
 if((fres)&&(resolv)){
  he=gethostbyaddr((char *)&i, sizeof(struct in_addr),AF_INET);
  if(he == NULL)
  strcpy(focus, inet_ntoa(i));
  else 
   strcpy(focus, he->h_name);
 } else 
  strcpy(focus, inet_ntoa(i));
 return focus;
}

void setup_interface(char *device){
 struct ifreq ifr;
 int s;

 sock=socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
 if(sock<0){
  printf("cant get SOCK_PACKET socket\n");
  exit(1);
 }
 strncpy(ifr.ifr_name, device,sizeof(ifr.ifr_name));
 if((s=ioctl(sock, SIOCGIFFLAGS, &ifr))==-1){
  close(sock);
  printf("cant get flags\n");
  exit(1);
 }
 if(promisc==1){
  ifr.ifr_flags |= IFF_PROMISC;
  if((s=ioctl(sock, SIOCSIFFLAGS, &ifr))==-1){
   printf("cant set promiscuous mode\n");
   exit(1);
  }
 }
}

void read_config(void){
char dump[300],type[20],intradump[20],secdump[270];
FILE *config;

 if((config=fopen("/etc/tgk-log","r"))==NULL){
  printf("Couldnt open config file\n");
  exit(1);
 }
 memset(intradump,0,sizeof(intradump)); memset(secdump,0,sizeof(secdump));
 memset(masq_ip,0,sizeof(masq_ip)); memset(intranet,0,sizeof(intranet));
 memset(tcplogfile,0,sizeof(tcplogfile));memset(dump,0,sizeof(dump));
 memset(udplogfile,0,sizeof(udplogfile));memset(type,0,sizeof(type));
 memset(device,0,sizeof(device)); memset(icmplogfile,0,sizeof(icmplogfile));
 memset(abuselogfile,0,sizeof(abuselogfile));
 
 while(!feof(config)){
  memset(dump,0,sizeof(dump));
  memset(type,0,sizeof(type));
  memset(secdump,0,sizeof(secdump));
  fgets(dump,sizeof(dump)-1,config);

  if((dump[0]!='#')&&(dump[0]!=0)){
 
   strncpy(type,strtok(dump," "),sizeof(type)-1);
   if(strncasecmp(type,"resolv",strlen("resolv"))==0)
    if(strncasecmp(strtok(NULL," \n\t"),"on",strlen("on"))==0)
     resolv=1;

   if(strncasecmp(type,"log-tcp",strlen("log-tcp"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logtcp=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logtcp=0;
    else {
     printf("log-tcp has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"log-udp",strlen("log-udp"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logudp=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logudp=0;
    else {
     printf("log-udp has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"log-icmp",strlen("log-icmp"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logicmp=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logicmp=0;
    else {
     printf("log-icmp has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

/*  if(strncasecmp(type,"log-abuse",strlen("log-abuse"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     logabuse=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     logabuse=0;
    else {
     printf("log-abuse has invalid value\n");
     fclose(config);
     exit(1);
    }
   }*/

   if(strncasecmp(type,"tcplogfile",strlen("tcplogfile"))==0)
    strncpy(tcplogfile,strtok(NULL," \n\t"),sizeof(tcplogfile)-1);
   if(strncasecmp(type,"udplogfile",strlen("udplogfile"))==0)
    strncpy(udplogfile,strtok(NULL," \n\t"),sizeof(udplogfile)-1);
   if(strncasecmp(type,"icmplogfile",strlen("icmplogfile"))==0)
    strncpy(icmplogfile,strtok(NULL," \n\t"),sizeof(icmplogfile)-1);
/*   if(strncasecmp(type,"abuselogfile",strlen("abuselogfile"))==0)
    strncpy(abuselogfile,strtok(NULL," \n\t"),sizeof(abuselogfile)-1);*/

   if(strncasecmp(type,"log_all",strlen("log_all"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"yes",strlen("yes"))==0)
     log_all=1;
    else if(strncasecmp(secdump,"no",strlen("no"))==0)
     log_all=0;
    else {
     printf("log_all has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"log_intranet",strlen("log_intranet"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     log_intra=1; 
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     log_intra=0;
    else {
     printf("log_intranet has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"log_outside_to_intranet",
     strlen("log_outside_to_intranet"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     log_out2intra=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     log_out2intra=0;
    else {
     printf("log_intranet has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"net_class",strlen("net_class"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"16",strlen("16"))==0)
     net_class=16;
    else if(strncasecmp(secdump,"24",strlen("24"))==0)
     net_class=24;
    else {
     printf("net_class has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"intranet",strlen("intranet"))==0){
    strncpy(intradump,strtok(NULL," \n\t"),sizeof(intradump)-1);
    if(inet_addr(intradump)==-1){
     printf("Invalid intranet IP in config file\n");
     fclose(config);
     exit(1);
    } 
   }

   if(strncasecmp(type,"promisc",strlen("promisc"))==0){
    strncpy(secdump,strtok(NULL," \n\t"),sizeof(secdump)-1);
    if(strncasecmp(secdump,"on",strlen("on"))==0)
     promisc=1;
    else if(strncasecmp(secdump,"off",strlen("off"))==0)
     promisc=0;
    else {
     printf("promisc has invalid value\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"masq_ip",strlen("masq_ip"))==0){
    strncpy(masq_ip,strtok(NULL," \n\t"),sizeof(masq_ip)-1);
    if(inet_addr(masq_ip)==-1){
     printf("Invalid masq_ip entry in config file\n");
     fclose(config);
     exit(1);
    }
   }

   if(strncasecmp(type,"device",strlen("device"))==0){
    strncpy(device,strtok(NULL," \n\t"),sizeof(device)-1);
    if(strncmp(device,"eth",strlen("eth"))!=0){
     printf("Invalid network device entered?\n");
     printf("Should be eth<something>\n");
     fclose(config);
     exit(1);
    } else {
     setup_interface(device);
    }    
   }
  }
 }
 fclose(config);

 if((logtcp==1)&&(tcplogfile[0]==0)){
  printf("log-tcp has value ON but no tcplogfile was entered\n");
  exit(1);
 }
 else if((logtcp==1)&&(tcplogfile[0]!=0)){
  if((tcpfile=fopen(tcplogfile,"a"))==NULL){
   printf("Couldn't open tcp logfile %s\n",tcplogfile);
   exit(1);
  }
 }

 if((logudp==1)&&(udplogfile[0]==0)){
  printf("log-udp has value ON but no udplogfile was entered\n");
  exit(1);
 }
 else if((logudp==1)&&(udplogfile[0]!=0)){
  if((udpfile=fopen(udplogfile,"a"))==NULL){
   printf("Couldn't open udp logfile %s\n",udplogfile);
   exit(1);
  }
 }

 if((logicmp==1)&&(icmplogfile[0]==0)){
  printf("log-icmp has value ON but no udplogfile was entered\n");
  exit(1);
 }
 else if((logicmp==1)&&(icmplogfile[0]!=0)){
  if((icmpfile=fopen(icmplogfile,"a"))==NULL){
   printf("Couldn't open icmp logfile %s\n",icmplogfile);
   exit(1);
  }
 }

/* if((logabuse==1)&&(abuselogfile[0]==0)){
  printf("log-abuse has value ON but no udplogfile was entered\n");
  exit(1);
 }
 else if((logabuse==1)&&(abuselogfile[0]!=0)){
  if((abusefile=fopen(abuselogfile,"a"))==NULL){
   printf("Couldn't open abuse logfile %s\n",abuselogfile);
   exit(1);
  }
 }*/

 if(device[0]==0){
  printf("You havent entered a network device in the config file\n");
  exit(1);
 }
 if(net_class==16){
  snprintf(intranet,sizeof(intranet)-1,"%s.",strtok(intradump,"."));
  strncat(intranet,strtok(NULL,"."),(sizeof(intranet)-1)-strlen(intranet));
  } else if(net_class==24){
   strncpy(intranet,intradump,strlen(intradump)-strlen(strrchr(intradump,'.')));
 }
}

int checkup(unsigned long sa, unsigned long da){
int value=1;

 if(log_all!=1){
  if((strncmp(hostlookup(da,0),intranet,strlen(intranet))==0)&&
    (strncmp(hostlookup(sa,0),intranet,strlen(intranet))==0)){
   if(log_intra==1)
    value=1;
   else if(log_intra==0)
    value=0;
  }
  if((strncmp(hostlookup(sa,0),intranet,strlen(intranet))!=0)&&
    (strncmp(hostlookup(da,0),intranet,strlen(intranet))==0)){
   if(log_out2intra==1)
    value=1;
   else if(log_out2intra==0)
    value=0;
  }
 }
 if(masq_ip[0]!=0){
  if((strncmp(hostlookup(sa,0),masq_ip,strlen(hostlookup(sa,0)))==0)||
    (strncmp(hostlookup(da,0),masq_ip,strlen(hostlookup(da,0)))==0))
  value=0; 
 }
return(value);
}

/*void check_for_abuse(unsigned long sa,unsigned long da,unsigned long offset,unsigned long len,unsigned int protocol){
 if((protocol==IPPROTO_UDP)&&(offset!=0))
  fprintf(abusefile,"%s -> %s offset: %d len: %d\n",hostlookup(sa,1),hostlookup(da,1),offset,len);           
 fflush(abusefile);
}*/

void write_node(unsigned long sa, unsigned long da,unsigned short sp,unsigned short dp,unsigned int pt){
time_t ptime;

 if(checkup(sa,da)){
  if(pt==IPPROTO_TCP){
   fprintf(tcpfile,"%s [%d] (",hostlookup(sa,1),ntohs(sp));
   fprintf(tcpfile,"%.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
           ep.eth.h_source[0],ep.eth.h_source[1],
           ep.eth.h_source[2],ep.eth.h_source[3],
           ep.eth.h_source[4],ep.eth.h_source[5]);
   fprintf(tcpfile,") => %s [%d] - ",hostlookup(da,1),ntohs(dp));
   fprintf(tcpfile,"%s\n",givetime(&ptime));
   fflush(tcpfile);
  } else if(pt==IPPROTO_UDP){
   fprintf(udpfile,"%s [%d] (",hostlookup(sa,0),ntohs(sp));
   fprintf(udpfile,"%.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
           ep.eth.h_source[0],ep.eth.h_source[1],
           ep.eth.h_source[2],ep.eth.h_source[3],
           ep.eth.h_source[4],ep.eth.h_source[5]);
   fprintf(udpfile,") => %s [%d] - ",hostlookup(da,0),ntohs(dp));
   fprintf(udpfile,"%s\n",givetime(&ptime));
   fflush(udpfile);
  } else if(pt==IPPROTO_ICMP){
   fprintf(icmpfile,"%s (",hostlookup(sa,1));
   fprintf(icmpfile,"%.2x:%.2x:%.2x:%.2x:%.2x:%.2x",
           ep.eth.h_source[0],ep.eth.h_source[1],
           ep.eth.h_source[2],ep.eth.h_source[3],
           ep.eth.h_source[4],ep.eth.h_source[5]);
   if((sp!=ICMP_DEST_UNREACH)&&(sp!=ICMP_REDIRECT)&&(sp!=ICMP_TIME_EXCEEDED))
    fprintf(icmpfile,") => %s [%s] - ",hostlookup(da,1),icmptype[sp]);
   else if(sp==ICMP_DEST_UNREACH)
    fprintf(icmpfile,") => %s [%s] [%s] - ",hostlookup(da,1),icmptype[sp],icmpunreach[dp]); 
   else if(sp==ICMP_REDIRECT)
    fprintf(icmpfile,") => %s [%s] [%s] - ",hostlookup(da,1),icmptype[sp],icmpredirect[dp]);
   else if(sp==ICMP_TIME_EXCEEDED)
    fprintf(icmpfile,") => %s [%s] [%s] - ",hostlookup(da,1),icmptype[sp],icmptime[dp]);
   fprintf(icmpfile,"%s\n",givetime(&ptime));
   fflush(icmpfile);
  }
 }
}

void cleanup(int sig){
struct ifreq ifr;
int s,sokka;

 if(sock)
  close(sock);
 if(logtcp)
  fclose(tcpfile);
 if(logudp)
  fclose(udpfile);
 if(logicmp)
  fclose(icmpfile);
/* if(logabuse)
  fclose(abusefile);*/

 sokka=socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
 if(sokka<0){
  printf("cant get SOCK_PACKET socket\n");
  exit(1);
 }
 strncpy(ifr.ifr_name, device,sizeof(ifr.ifr_name));
 if((s=ioctl(sokka, SIOCGIFFLAGS, &ifr))==-1){
  close(sokka);
  printf("cant get flags\n");
  exit(1);
 }
 if(promisc==1){
  ifr.ifr_flags -= IFF_PROMISC ;
  if((s=ioctl(sokka, SIOCSIFFLAGS, &ifr))==-1){
   printf("cant set promiscuous mode\n");
   exit(1);
  }
 }
 close(sokka);
 exit(1);
}

void reread(int sig){
struct ifreq ifr;
int s,sokka;

 if(sock)
  close(sock);
 if(logtcp)
  fclose(tcpfile);
 if(logudp)
  fclose(udpfile);
 if(logicmp)
  fclose(icmpfile);
/* if(logabuse)
  fclose(abusefile);*/

 sokka=socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL));
 if(sokka<0){
  printf("cant get SOCK_PACKET socket\n");
  exit(1);
 }
 strncpy(ifr.ifr_name, device,sizeof(ifr.ifr_name));
 if((s=ioctl(sokka, SIOCGIFFLAGS, &ifr))==-1){
  close(sokka);
  printf("cant get flags\n");
  exit(1);
 }
 if(promisc==1){
  ifr.ifr_flags -= IFF_PROMISC ;
  if((s=ioctl(sokka, SIOCSIFFLAGS, &ifr))==-1){
   printf("cant set promiscuous mode\n");
   exit(1);
  }
 }
 close(sokka);
 read_config();
}

void decide(void){
 if((ip->protocol==IPPROTO_TCP)&&(logtcp==1)){	
  if(tcp->syn)
   write_node(ip->saddr,ip->daddr,tcp->source,tcp->dest,ip->protocol);
 }
 else if((ip->protocol==IPPROTO_UDP)&&(logudp==1)){
// check_for_abuse(ip->saddr,ip->daddr,ip->frag_off,ip->tot_len,ip->protocol);
  write_node(ip->saddr,ip->daddr,udp->source,udp->dest,ip->protocol);
 }
 else if((ip->protocol==IPPROTO_ICMP)&&(logicmp==1)){
  write_node(ip->saddr,ip->daddr,icmp->type,icmp->code,ip->protocol);
 }
}

int main(int argc, char *argv[]){
 int x,dn;	
 ip=(struct iphdr *)(((unsigned long)&ep.ip)-2);
 tcp=(struct tcphdr *)(((unsigned long)&ep.buffert)-2);
 udp=(struct udphdr *)(((unsigned long)&ep.buffert)-2);
 icmp=(struct icmphdr *)(((unsigned long)&ep.buffert)-2);
 read_config();

 if (fork()==0){
  close(0);close(1);close(2);
  setsid();
  chdir("/");
  umask(0);
  dn=open("/dev/null",O_RDWR);
  dup2(0,dn); dup2(1,dn); dup2(2,dn);
  close(dn);

  signal(SIGINT, cleanup);
  signal(SIGTERM, cleanup);
  signal(SIGKILL, cleanup);
  signal(SIGQUIT, cleanup);
  signal(SIGHUP, reread);
	
  while(1){
   x=read(sock, (struct etherpacket *)&ep, sizeof(struct etherpacket));
   if(x>1)
    decide();
  }
 }
return(0);
}
